---
title: Error.prototype.toSource()
slug: Web/JavaScript/Reference/Global_Objects/Error/toSource
tags:
  - JavaScript
  - Method
  - Non-standard
  - Prototype
---
<div>{{JSRef}} {{non-standard_header}}</div>

<p>The <code><strong>toSource()</strong></code> method returns code that could eval to the same error.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>e</var>.toSource()</pre>

<h3 id="Return_value">Return value</h3>

<p>A string containing the source code of the error.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_toSource">Using toSource</h3>

<p>Calling the <code>toSource</code> method of an {{jsxref("Error")}} instance (including <em><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error#Error_types">NativeErrors</a></em>) will return a string containing the source code of the error. This string can be evaluated to create an (approximately) equal object. Naturally, the string containing the source follows the structure of the {{jsxref("Error")}} constructor. For example:</p>

<pre class="brush: js notranslate">(new<em>name</em>(<em>message</em> ,<em>fileName</em>,<em>lineNumber</em>))
</pre>

<p>where these attributes correspond to the respective properties of the error instance.</p>

<div class="note">
<p><strong>Note:</strong> Be aware that the properties used by the <code>toSource</code> method in the creation of this string are mutable and may not accurately reflect the function used to create an error instance or the filename or line number where the actual error occurred.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Error.toSource")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Error.prototype.fileName")}}</li>
 <li>{{jsxref("Error.prototype.lineNumber")}}</li>
 <li>{{jsxref("Error.prototype.message")}}</li>
 <li>{{jsxref("Error.prototype.name")}}</li>
 <li>{{jsxref("Object.prototype.toSource()")}}</li>
</ul>
